# ServerManagement

> see https://aka.ms/autorest

This is the AutoRest configuration file for ServerManagement.



---
## Getting Started
To build the SDK for ServerManagement, simply [Install AutoRest](https://aka.ms/autorest/install) and in this folder, run:

> `autorest`

To see additional help and options, run:

> `autorest --help`
---

## Configuration



### Basic Information
These are the global settings for the ServerManagement API.

``` yaml
openapi-type: arm
tag: package-2016-07-preview
```


### Tag: package-2016-07-preview

These settings apply only when `--tag=package-2016-07-preview` is specified on the command line.

``` yaml $(tag) == 'package-2016-07-preview'
input-file:
- Microsoft.ServerManagement/preview/2016-07-01-preview/servermanagement.json
```

### Tag: package-2015-07-preview

These settings apply only when `--tag=package-2015-07-preview` is specified on the command line.

``` yaml $(tag) == 'package-2015-07-preview'
input-file:
- Microsoft.ServerManagement/preview/2015-07-01-preview/servermanagement.json
```


---
# Code Generation


## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-python
  - repo: azure-sdk-for-java
  - repo: azure-sdk-for-go
  - repo: azure-sdk-for-node
  - repo: azure-sdk-for-ruby
    after_scripts:
      - bundle install && rake arm:regen_all_profiles['azure_mgmt_server_management']
```


## C#

These settings apply only when `--csharp` is specified on the command line.
Please also specify `--csharp-sdks-folder=<path to "SDKs" directory of your azure-sdk-for-net clone>`.

``` yaml $(csharp)
csharp:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  namespace: Microsoft.Azure.Management.ServerManagement
  output-folder: $(csharp-sdks-folder)/ServerManagement/Management.ServerManagement/Generated
  clear-output-folder: true
```

## Python

These settings apply only when `--python` is specified on the command line.
Please also specify `--python-sdks-folder=<path to the root directory of your azure-sdk-for-python clone>`.
Use `--python-mode=update` if you already have a setup.py and just want to update the code itself.

``` yaml $(python)
python-mode: create
python:
  azure-arm: true
  license-header: MICROSOFT_MIT_NO_VERSION
  payload-flattening-threshold: 2
  namespace: azure.mgmt.servermanager
  package-name: azure-mgmt-servermanager
  clear-output-folder: true
```
``` yaml $(python) && $(python-mode) == 'update'
python:
  no-namespace-folders: true
  output-folder: $(python-sdks-folder)/azure-mgmt-servermanager/azure/mgmt/servermanager
```
``` yaml $(python) && $(python-mode) == 'create'
python:
  basic-setup-py: true
  output-folder: $(python-sdks-folder)/azure-mgmt-servermanager
```



## Go

These settings apply only when `--go` is specified on the command line.

``` yaml $(go)
go:
  license-header: MICROSOFT_APACHE_NO_VERSION
  namespace: servermanagement
  clear-output-folder: true
```

### Go multi-api

``` yaml $(go) && $(multiapi)
batch:
  - tag: package-2016-07-preview
  - tag: package-2015-07-preview
```

### Tag: package-2016-07-preview and go

These settings apply only when `--tag=package-2016-07-preview --go` is specified on the command line.
Please also specify `--go-sdk-folder=<path to the root directory of your azure-sdk-for-go clone>`.

``` yaml $(tag) == 'package-2016-07-preview' && $(go)
output-folder: $(go-sdk-folder)/services/preview/servermanagement/mgmt/2016-07-01-preview/servermanagement
```

### Tag: package-2015-07-preview and go

These settings apply only when `--tag=package-2015-07-preview --go` is specified on the command line.
Please also specify `--go-sdk-folder=<path to the root directory of your azure-sdk-for-go clone>`.

``` yaml $(tag) == 'package-2015-07-preview' && $(go)
output-folder: $(go-sdk-folder)/services/preview/servermanagement/mgmt/2015-07-01-preview/servermanagement
```


## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
azure-arm: true
fluent: true
namespace: com.microsoft.azure.management.servermanagement
license-header: MICROSOFT_MIT_NO_CODEGEN
payload-flattening-threshold: 1
output-folder: $(azure-libraries-for-java-folder)/azure-mgmt-servermanagement
```

### Java multi-api

``` yaml $(java) && $(multiapi)
batch:
  - tag: package-2015-07-preview
  - tag: package-2016-07-preview
```

### Tag: package-2015-07-preview and java

These settings apply only when `--tag=package-2015-07-preview --java` is specified on the command line.
Please also specify `--azure-libraries-for-java=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag) == 'package-2015-07-preview' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.servermanagement.v2015_07_01_preview
  output-folder: $(azure-libraries-for-java-folder)/servermanagement/resource-manager/v2015_07_01_preview
regenerate-manager: true
generate-interface: true
```

### Tag: package-2016-07-preview and java

These settings apply only when `--tag=package-2016-07-preview --java` is specified on the command line.
Please also specify `--azure-libraries-for-java=<path to the root directory of your azure-sdk-for-java clone>`.

``` yaml $(tag) == 'package-2016-07-preview' && $(java) && $(multiapi)
java:
  namespace: com.microsoft.azure.management.servermanagement.v2016_07_01_preview
  output-folder: $(azure-libraries-for-java-folder)/servermanagement/resource-manager/v2016_07_01_preview
regenerate-manager: true
generate-interface: true
```


